---
title: 'HTML attribute: minlength'
slug: Web/HTML/Attributes/minlength
tags:
  - Attribute
  - HTML
  - Input
  - Reference
  - minlength
  - textarea
---
<p>{{HTMLSidebar}}</p>

<p class="summary">The <strong><code>minlength</code></strong> attribute defines the minimum number of characters (as UTF-16 code units) the user can enter into an {{htmlelement('input')}} or {{htmlelement('textarea')}}. This must be an integer value 0 or higher. If no minlength is specified, or an invalid value is specified, the input has no minimum length. This value must be less than or equal to the value of <a href="/en-US/docs/Web/HTML/Attributes/maxlength">maxlength</a>, otherwise the value will never be valid, as it is impossible to meet both criteria.</p>

<p>The input will fail constraint validation if the length of the text value of the field is less than minlength UTF-16 code units long, with {{domxref('validityState.tooShort')}} returning <code>true</code>. Constraint validation is only applied when the value is changed by the user. Once submission fails, some browsers will display an error message indicating the minimum length required and the current length.</p>

<h2 id="Examples">Examples</h2>

<p>By adding <code>minlength="5"</code>, the value must either be empty or five characters or longer to be valid.</p>

<pre class="brush: html notranslate">&lt;label for="fruit"&gt;Enter a fruit name that is at least 5 letters long&lt;/label&gt; &lt;input type="text" minlength="5" id="fruit"&gt;</pre>

<p>We can use pseudoclasses to style the element based on whether the value is valid. The value will be valid as long as it is either null (empty) or five or more characters long. <em>Lime</em> is invalid, <em>lemon is valid</em>.</p>

<pre class="brush: css notranslate">input {
  border: 2px solid currentcolor;
}
input:invalid {
  border: 2px dashed red;
}
input:invalid:focus {
  background-image: linear-gradient(pink, lightgreen);
}</pre>

<p>{{EmbedLiveSample('Examples', '100%', 200)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'input.html#attr-input-minlength', 'minlength attribute')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'input.html#attr-minlength-accept', 'minlength attribute')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.attribute.minlength")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTML/Attributes/maxlength">maxlength</a></li>
 <li><a href="/en-US/docs/Web/HTML/Attributes/size">size</a></li>
 <li><a href="/en-US/docs/Web/HTML/Attributes/pattern">pattern</a></li>
 <li><a href="/en-US/docs/Web/Guide/HTML/HTML5/Constraint_validation">Constraint validation</a></li>
</ul>
